      subroutine rantab_ini(rtab,iseed1,iseed2,iflag)
      use mod_plot  ! HYCOM plot array interface
c
      real*4     rtab(200,2)
      integer*2 iseed1,iseed2
      integer*4 iflag
c
c --- get the two seeds
c --- iseed1 is for the 'usual'    random number generator  (udev_rt)
c --- iseed2 is for the 'gaussian' random number generator (grand_rt)
c
      integer*4 seed
      integer*2 isd2(2)
      equivalence (isd2,seed)
c
      call system_clock(inisee)
cdiag write(*,*)'calc itime',time()
      itime = inisee
      seed = 123456789
      iseed1 = isd2(1)
      if (iseed1 .lt. 0) then
        iseed1 = iabs (iseed1)
      endif
      iseed1 = iseed1 + itime*iflag
cdiag write(*,*)'iseed1',iseed1
      seed = 987654321
      iseed2 = isd2(2)
      if (iseed2 .lt. 0) then
        iseed2 = iabs (iseed1)
      endif
      iseed2 = iseed2 + itime*iflag
cdiag write(*,*)'iseed2',iseed2
c
c --- set seeds to negative values if iflag=1
c
      if (iflag .eq. 1) then
        iseed1 = -iseed1
        iseed2 = -iseed2
      endif
c
c --- load the table with a sequence of 200 random numbers.
      do  ic = 1,200
        rtab(ic,1) =  udev_rt(iseed1)
        rtab(ic,2) = grand_rt(iseed2)
      enddo
cdiag write(*,*)'rtabs',rtab(100,1),rtab(100,2)
c
      return
      end subroutine rantab_ini

      subroutine rantab (rtab,iseed1,iseed2,numran)
c
c --- each time this routine is called one of the 200 records in "rtab"
c --- is randomly selected and new random numbers are inserted
c
      real*4 rtab(200,2)
c
c --- pick a number between 1 and 200
      numran = nint(1+199*udev_rt(iseed1))
      if (numran .gt. 200) then
        numran = 200
      endif
c
c --- get new random numbers
      rtab(numran,1) =  udev_rt(iseed1)
      rtab(numran,2) = grand_rt(iseed2)
c
      return
      end subroutine rantab
c
      real function grand_rt(idum)
c
c provides random number from gaussian distribution, mean 0, varaince 1,
c for finding random component of turbulent u
c
c from arthur mariano using routines from numerical recipes
c
      data iset/0/
      save iset,gset
c
      if (iset.eq.0) then
 1      v1=2.*udev_rt(idum)-1.0
        v2=2.*udev_rt(idum)-1.0
        r=v1**2+v2**2
        if (r.ge.1.0)go to 1
        fac=sqrt(-2.*log(r)/r)
        gset=v1*fac
        grand_rt=v2*fac
        iset=1
      else
        grand_rt=gset
        iset=0
      endif
c
      return
      end function grand_rt
c
      real function udev_rt(iseed)

      parameter (m=714025,ia=1366,ic=150889,rm=1./m)

      dimension ir(97)

      data iff / 0 /
c
      if (iseed .lt. 0 .or. iff .eq. 0) then
        iff = 1
        iseed = mod(ic-iseed,m)
        do j=1,97
          iseed = mod(ia*iseed+ic,m)
          ir(j) = iseed
        enddo
        iseed = mod(ia*iseed+ic,m)
      else
        iseed = mod(iseed,m)
      endif
      iy=iseed
      j = min(97,1+(97*iy)/m)
      iy = ir(j)
      udev_rt = iy*rm
      iseed = mod(ia*iseed+ic,m)
      ir(j) = iseed
      return
      end function udev_rt
