      subroutine sample(alon,alat,depcut,flag,array,iloc,jloc,value)
      use mod_plot  ! HYCOM plot array interface
      use mod_za    ! HYCOM array I/O interface
c
c --- sample a model field in the horizontal by 2-d piecewise bilinear
c --- interpolation from 4 surrounding grid points
c
      integer iloc,jloc
      real alon,alat,depcut,flag,array(ii,jj),value
c
c --- search for the reference p grid point. make sure that the four
c --- surrounding grid points are all water points deeper than depcut.
c
      iloc=0
      jloc=0
c
c --- longitudes must be between -180 and +180 
c
      alomax = -99999.0
      alomin =  99999.0
      do i=1,ii
        do j=1,jj
          alomax = max(alomax,plon(i,j))
          alomin = min(alomin,plon(i,j))
        enddo
      enddo
      if     (alomax.gt.180.0) then
        aloshf = -360.0
      elseif (alomin.lt.-180.0) then
        aloshf =  360.0
      else
        aloshf = 0.0
      endif
      do j=1,jj-2
        do i=1,ii-2
c
          alomin=min(plon(i  ,j  ),plon(i  ,j+1),
     &               plon(i+1,j  ),plon(i+1,j+1))+aloshf
          alomax=max(plon(i  ,j  ),plon(i  ,j+1),
     &               plon(i+1,j  ),plon(i+1,j+1))+aloshf
          alamin=min(plat(i,j),plat(i,j+1),plat(i+1,j),plat(i+1,j+1))
          alamax=max(plat(i,j),plat(i,j+1),plat(i+1,j),plat(i+1,j+1))
c
          if (alon.ge.alomin .and. alon.lt.alomax .and.
     &        alat.ge.alamin .and. alat.lt.alamax) then
            if (p(i  ,j  ,kk+1).gt.depcut .and.
     &          p(i+1,j  ,kk+1).gt.depcut .and.
     &          p(i  ,j+1,kk+1).gt.depcut .and.
     &          p(i+1,j+1,kk+1).gt.depcut) then
              iloc = i
              jloc = j
              go to 10
            endif
          endif
c
        enddo
      enddo
   10 continue
c
c --- do the bilinear interpolation
c
      if (iloc.gt.0 .and. jloc.gt.0) then
c
        if (array(iloc  ,jloc  ).ne.flag .and.
     &      array(iloc+1,jloc  ).ne.flag .and.
     &      array(iloc  ,jloc+1).ne.flag .and.
     &      array(iloc+1,jloc+1).ne.flag) then
          dx = alon-plon(iloc,jloc)-aloshf
          dy = alat-plat(iloc,jloc)
          value = (1.0-dy)*((1.0-dx)*array(iloc  ,jloc  ) +
     &                           dx *array(iloc+1,jloc  ))+
     &                 dy *((1.0-dx)*array(iloc  ,jloc+1) +
     &                           dx *array(iloc+1,jloc+1))
        else
          value = flag
          iloc = 0
          jloc = 0
        endif
c
      else
        value=flag
      endif
c
      return
      end
c
c     end subroutine sample
